/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package aabb;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.util.LinkedList;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTextArea;

/**
 *
 * @author Lukas
 */
public class window {

    Canvas c;
    Graphics g;
    Image plocha;
    Graphics img;
    LinkedList<box> boxes = new LinkedList<box>();
    boolean end= false;
    long sumS=0;
    int pocS=0;
    long sumH=0;
    int pocH=0;
    JTextArea out;
    T thr;

    public window(Canvas cc) {
        c = cc;
        g = c.getGraphics();
        thr= new T(this);


        c.addMouseMotionListener(new MouseMotionListener() {

            public void mouseDragged(MouseEvent e) {
                //throw new UnsupportedOperationException("Not supported yet.");
            }

            public void mouseMoved(MouseEvent e) {
                
                if (g == null) {
                    g = c.getGraphics();
                    start();
                }
                g.drawImage(plocha, 0, 0, c);
            }
        });
    }

    private int sgn(int a) {
        return a > 0 ? 1 : a < 0 ? -1 : 0;
    }

    public void addOut(JTextArea j){
        out=j;
    }

    public void start() {
        init();
        Random r = new Random();
        int p = r.nextInt(10) + 10;

        for (int i = 0; i < p; i++) {
            addBox();
        }
        draw();
        thr.start();
        

    }

    public void draw() {
        img.setColor(Color.white);
        img.fillRect(0, 0, c.getWidth(), c.getHeight());
        img.setColor(Color.black);

        for (int i = 0; i < boxes.size(); i++) {
            img.drawRect(boxes.get(i).x, boxes.get(i).y, boxes.get(i).a, boxes.get(i).b);
        }
    }

    public void init() {
        plocha = new BufferedImage(c.getWidth(), c.getHeight(), 2);
        img = plocha.getGraphics();
        img.setColor(Color.white);
        img.fillRect(0, 0, c.getWidth(), c.getHeight());
    }

    public void move() {
        for (int i = 0; i < boxes.size(); i++) {
            updateBox(i);
        }
    }

    public int addBox() {
        Random r = new Random();
        return addBox(r.nextInt(c.getWidth() - 100), r.nextInt(c.getHeight() - 100), r.nextInt(50) + 50, r.nextInt(50) + 50, r.nextInt(7) - 3, r.nextInt(7) - 3);
    }

    public int addBox(int x, int y, int a, int b, int dx, int dy) {
        boxes.add(new box(x, y, a, b, dx, dy));
        return (boxes.size() - 1);
    }

    public void removeBox(int i) {
        boxes.remove(i);
    }

    public void updateBox(int i) {
        boxes.get(i).update();
        boxes.get(i).control(c.getWidth(), c.getHeight());
    }

    public void rep(){
        g.drawImage(plocha, 0, 0, c);
    }

    public void controlColision() {
        long time = System.nanoTime();
        SimplePair sp = new SimplePair();
        for (int i = 0; i < (boxes.size() - 1); i++) {
            for (int j = i+1; j < boxes.size(); j++) {
                if (control(i, j) && !sp.findPair(i, j)) {
                    img.setColor(Color.green);
                    img.drawLine(boxes.get(i).x+ boxes.get(i).a/2, boxes.get(i).y+ boxes.get(i).b/2, boxes.get(j).x+ boxes.get(j).a/2, boxes.get(j).y+ boxes.get(j).b/2);
                    img.setColor(Color.black);
                    sp.addPair(i, j);
                } else if (!control(i, j) && sp.findPair(i, j)) {
                    sp.deletePair(i, j);
                }
            }
        }
        out.insert("\n"+sp.getPairs() , 0);
        System.out.print(sp.getPairs());
        long t = System.nanoTime();
        //sumS+=(t-time);
        //pocS++;
        int msek = Math.round((t - time) / 1000);
        int nsek = Math.round((t - time)) - 1000 * msek;
        out.insert(" ,time, msek:" + msek + " nsek:" + nsek, 0);
        //System.out.println(" ,time, msek:" + msek + " nsek:" + nsek);
        time = System.nanoTime();

        HashPair hp = new HashPair();

        for (int i = 0; i < (boxes.size() - 1); i++) {
            for (int j = i + 1; j < boxes.size(); j++) {
                if (control(i, j) && !hp.findPairs(i, j)) {
                    hp.addPairs(i, j);
                    img.setColor(Color.red);
                    img.drawLine(boxes.get(i).x+ boxes.get(i).a/2, boxes.get(i).y+ boxes.get(i).b/2, boxes.get(j).x+ boxes.get(j).a/2, boxes.get(j).y+ boxes.get(j).b/2);
                    img.setColor(Color.black);
                } else if (!control(i, j) && hp.findPairs(i, j)) {
                    hp.deletePairs(i, j);
                }
            }
        }
        out.insert("\n"+hp.getPairs() , 0);
        //System.out.print(hp.getPairs());
        t = System.nanoTime();
        //sumH+=(t-time);
        //pocH++;
        msek = Math.round((t - time) / 1000);
        nsek = Math.round((t - time)) - 1000 * msek;
        out.insert(" ,time, msek:" + msek + " nsek:" + nsek , 0);
        //System.out.println(" ,time, msek:" + msek + " nsek:" + nsek);
        //System.out.println("simple:" +(sumS/pocS)+"hash:" +(sumH/pocH));

    }

    public boolean control(int i, int j) {
        box a = boxes.get(i);
        box b = boxes.get(j);

        if ((a.x > (b.x+b.a)) || (a.y > (b.y+b.b))
                || ((a.x+a.a) < b.x) || ((a.y+a.b) < b.y)) {
            return false;
        }
        return true;

    }
    public void changeTime(int time){
        thr.time=time;
    }
}
